

import javax.print.DocFlavor;
import java.util.*;

public class Shop {

    private String nameOfShop;
    private ArrayList <Customer> Customers = new ArrayList<Customer> ( );
    private ArrayList <Repository> Repositorys = new ArrayList<Repository>();
    private ArrayList <Good> Goods             = new ArrayList<Good>();
   private ArrayList<Order > orders = new ArrayList<Order>();
    private static int income =0;

    public void addCustomer(Customer C)
    { Customers.add(C); }
    public ArrayList<Customer> getCustomers()
    { return Customers; }
    public void addRepository(Repository R)
    { Repositorys.add(R);}
    public ArrayList<Repository> getRepository()
    { return Repositorys;}
    public int getIncome(){return  income;}
    public void setIncome(int income){this.income = income;}
    public void addGood(Good g){ Goods.add(g);}
    public void increamentGood(Good good, int amount)
    {

  int d= Repositorys.size();
  Goods.add(good);
  Repository arr [ ] = new Repository[d];

        for (int i = 0; i < d; i++) {

            arr[i] = Repositorys.get(i);
                                                 }
        Arrays.sort(arr,new SortbyFreeCapacity());

        for (Repository repository: arr) {
             if (repository.getFreeCapacity()> amount)
             {
                 repository.addGood(good,amount);
                 break;
             }

        }
    }

    static class SortbyFreeCapacity implements Comparator<Repository>
    {
        // Used for sorting in ascending order of
        // roll number
        public int compare(Repository a, Repository b)
        {
            return a.getFreeCapacity()- b.getFreeCapacity();
        }

    }
    // public void addDiscount(Discount d, Customer c){}
    // public HashMap<Good, Integer> getItemsSold(){};


static class Repository{

        private int id;
        private int capacity;
        private int filledCapacity;

        private HashMap < Good , Integer> listOfGoodsinRepository = new HashMap<Good,Integer>();

        private Repository(int id ,int capacity)
        {
            this.id = id;
            this.capacity = capacity;
            this.filledCapacity =0;
        }
        public  HashMap <Good,Integer> getListOfGoodsinRepository()
        { return listOfGoodsinRepository; }
        public void removeGood(Good good, int amount)
        {
            int remain ;
            remain = listOfGoodsinRepository.get(good);

            if( (remain - amount) > 0 )
            {
                listOfGoodsinRepository.replace(good,remain,remain-amount);
                filledCapacity = filledCapacity -amount;
            }
        }

        public void addGood( Good good , int amount)
        {
            if(listOfGoodsinRepository.containsKey(good) )
            {
                listOfGoodsinRepository.replace(good,listOfGoodsinRepository.get(good),listOfGoodsinRepository.get(good)+amount);

                filledCapacity +=amount;


            }
            else {
            listOfGoodsinRepository.put(good,amount);
            filledCapacity+= amount;
                                    }
                                                                }

        public int getId() {
            return id;
        }
        public int getCapacity()
        {
            return capacity;
        }
        public int getFreeCapacity()
        { return  (capacity -filledCapacity);}

    }
    static  class Good{
        private  int id;
        private int price ;
        private String name;
        public Good(int id ,String name, int price)
        {
            this.id= id;
            this.name= name;
            this.price =price;
        }
        public int getId()
        { return id; }
        public int getPrice()
        {return  price;}
        public String getName()
        { return name;}

    }
     static class Customer{

        private String name;
        private int ID;
        private int balance;
        ArrayList <Order> orders = new ArrayList<Order>();
        ArrayList <Order> pendingOrders = new ArrayList<Order>();
        public Customer (String name ,int id)
        { this.name = name;
            ID = id;
        }
        public int getID(){return  ID;}
        public String getName () {return  name;}
        public int getBalance(){return balance;}
        public void setBalance(int amount)
        {
            balance = amount;
        }
        public void addorder(Order o)
        {
            orders.add(o);
        }
        public ArrayList<Order> getTOtalOrder()
        { return orders; }
        public ArrayList<Order> getPendingOrders()
        {
            return pendingOrders;
        }



    }
   static class Order{
        private   int ID;
        private String status;
        private  Customer c;
        HashMap <Good,Integer> Items = new HashMap<Good,Integer>();

        public Order(int id , Customer c)
        {
            ID = id;
            this.c = c;
            this.status = "pending";
        }

        public int getID()
        {
            return ID;
        }
        public String getStatus()
        {
            return status;
        }
        public HashMap<Good,Integer> getItems()
        {
            return Items;
        }
        public void setStatus(String status)
        {
            this.status = status;}
        public void addItem(Good good, int amount)
        {
            if( Items.containsKey(good)){
                int Oldamount = Items.get(good);
                int Newamount = Oldamount + amount;
                Items.replace(good, Oldamount, Newamount);
            }
            else {
                Items.put(good , amount);
            }

        }
        public void removeItem(Good good)
        {
            Iterator<Good> it = Items.keySet().iterator();
            while(it.hasNext())
            {
                Good sample = it.next();
                if ( sample.getId() == good.getId() ) it.remove();
            }
        }





    }
    public class Discount{
        //todo to compelete Discount class;
  private int id;
  private int percent;
  public Discount(int id,int percent)
  {
      this.id = id;
      this.percent = percent;
  }
  public void setOrder( Order order)
  {


  }




    }

    public static void main(String[] args)
    {

        String entering;
        Shop MyShop =new Shop();
        Scanner scan = new Scanner(System.in) ;

        while(true){
            entering = scan.nextLine();
            if(entering.equals("terminate")) return;
            if(entering.equals( "add"))
            {
                String add = scan.nextLine();
                if (add.equals("customer")) {
                    int id = scan.nextInt();
                    String name = scan.nextLine();
                    Customer c = new Customer(name,id);
                    MyShop.addCustomer(c);
                }
                if(add.equals("good"))
                {

                    int id = scan.nextInt();

                    scan.nextLine();
                    String name =scan.nextLine();

                    int price = scan.nextInt();

                    int amount = scan.nextInt();

                    Good good = new Good(id,name,price);
                    MyShop.addGood(good);
                    MyShop.increamentGood(good,amount);

                }
                if(add.equals("repository"))
                {
                    int id =scan.nextInt();
                    int capacity= scan.nextInt();
                    Repository store = new Repository(id,capacity);
                    MyShop.addRepository(store);
                }
                if(add.equals("order"))
                {
                    int idOfOrder = scan.nextInt();
                    int idOfCustomer = scan.nextInt();
                    // Order order = new Order(idOfOrder);


                    Customer c = null;
                    for( Customer customer : MyShop.Customers)
                        if(customer.getID()==idOfCustomer) c =customer;
                    Order order = new Order(idOfOrder,c);
                    MyShop.orders.add(order);

                }
                if(add.equals("balance"))
                {
                    int IdOfCustomer =scan.nextInt();
                    int balance = scan.nextInt();
                    Customer c = null;
                    for(Customer customer : MyShop.Customers)
                    {
                        if(customer.getID() == IdOfCustomer)
                            c = customer;
                    }
                    int OldBalance = c.getBalance();
                    int NewBalance = OldBalance + balance;
                    c.setBalance(NewBalance);
                }
                if(add.equals("item"))
                {
                    int idOfOrder = scan.nextInt();
                    int IdOfGood = scan.nextInt();
                    int NumberOfGood = scan.nextInt();

                    for(Order order : MyShop.orders){

                        if(order.getID() == idOfOrder)
                        {
                            for (Good good : order.getItems().keySet())
                            {
                                if (good.getId() == IdOfGood)
                                {
                                    int oldNuberOfGood = order.getItems().get(good);
                                    order.getItems().replace(good, oldNuberOfGood ,oldNuberOfGood+NumberOfGood);

                                }
                                else {
                                    order.Items.put(good,NumberOfGood);
                                }
                            }
                        }


                    }
                }}
            if(entering.equals("report"))
            {
                // except customers others are complete;
                String report = scan.nextLine();

                if( report.equals("repositories"))
                {
                    for( Repository repo : MyShop.Repositorys) {
                        System.out.println(repo.id+","+repo.capacity+","+repo.getFreeCapacity()); }
                }
                if(report.equals("income")){
                    System.out.println(MyShop.getIncome());
                }
                if(report.equals("customers"));/*
               //todo about custromers
               {
                   for (Customer customer : MyShop.Customers){
                       System.out.println(customer.getID()+","+customer.getName()+","+customer.getBalance()+",");
                   }}*/

            }
            if(entering.equals("submit"))
            {
                String submit = scan.nextLine();
                if(submit.equals("order"))
                {
                    int IdOfOrder = scan.nextInt();
                    for( Order order : MyShop.orders)
                    {
                        if(order.getID() == IdOfOrder)
                            order.setStatus("submitted");
                    }
                    //todo if we submit we must decrease the repositry
                    // which repositry to decrease >>??
                }
                if(submit.equals("discount"))
                {
                    int IdOfOrder = scan.nextInt();
                    int IdOfPercet = scan.nextInt();

                }
            }


        }

    }

    }



